from twisted.trial import unittest
import test_domish
import test_msn
import os
import sys
import debug

# Runs selected unit tests against Twisted to ensure that we're using a good version

out = []

def runMSNTests():
	out.append("msn START!")
	t = test_msn.NotificationTests()
	out.append("msn setUp")
	t.setUp()
	out.append("msn testLogin")
	t.testLogin()
	out.append("msn testProfile")
	t.testProfile()
	out.append("msn testStatus")
	t.testStatus()
	out.append("msn testListSync")
	t.testListSync()
	out.append("msn testNotificationMessage")
	t.testNotificationMessage()
	out.append("msn testPingServer")
	t.testPingServer()
	out.append("msn tearDown")
	t.tearDown()
	out.append("msn DONE!")

def runXMLTests():
	out.append("domish START!")
	t = test_domish.DomishStreamTestCase()
	out.append("domish testExpatStream")
	try:
		t.testExpatStream()
	except unittest.SkipTest, message:
		debug.log("Tests: " + message)
	out.append("domish testSuxStream")
	t.testSuxStream()
	out.append("domish DONE!")


try:
	runMSNTests()
	runXMLTests()
except:
	print "Twisted tests FAILED! You cannot run PyMSNt without a good version of Twisted, or weird bugs will crop up."
	print "Debug output:\n%s\n%s\nDebug finish." % ("\n".join(out), sys.exc_info()[0])
	print "You are using a non-patched version of Twisted. Please download the latest patched version from http://msn-transport.jabberstudio.org"
	os.abort()
